#lang racket


(require "interp.rkt")

(define (test n v expected)
  (if (equal? v expected)
      (pretty-print (format "Test ~a Passed" n))
      (pretty-print (format "Test ~a failed! *********" n))))

(define test0 '(lambda (x) (lambda (y) x)))
(define v0 (interp test0))
(test 0 ((v0 7) 8) 7)


(define test1 '(lambda (x y) x))
(define v1 (interp test1))
(test 1 (v1 7 8) 7)

(define test2 '(let ([a (lambda (x) x)]) (let ([a (lambda (x) (lambda (x) x))][b a]) b)))
(define v2 (interp test2))
(test 2 (v2 7) 7)

(define test3 '(letrec ([mymap (lambda (f lst)
                                 (if (null? lst)
                                     lst
                                     (cons (f (car lst)) (mymap f (cdr lst)))))])
                 (mymap (lambda (x) (* 3 x))
                        (cons 1 (cons 2 (cons 3 '()))))))
(define v3 (interp test3))
(test 3 v3 '(3 6 9))



